import serial, time, sys
import os
import re
import struct

ser=serial.Serial('COM4', 223721, timeout=0)
ser.flushOutput()
ser.flushInput()

def dump():
	f = open(sys.argv[2], 'wb')
	addr = int(sys.argv[3],16)
	sz = int(sys.argv[4],16)
	ser.write('d')
	ser.write(struct.pack('>I',addr))
	ser.write(struct.pack('>I',sz))
	while sz:
		count = ser.inWaiting()
		f.write(ser.read(count))
		sz = sz - count
	f.close()

def jump():
	addr = int(sys.argv[2],16)
	ser.write('j')
	ser.write(struct.pack('>I',addr))

def run(cmd):
	addr = int(sys.argv[3],16)
	sz = os.path.getsize(sys.argv[2])
	ser.write(cmd)
	ser.write(struct.pack('>I',addr))
	ser.write(struct.pack('>I',sz))
	time.sleep(0.2)
	ser.write(open(sys.argv[2],'rb').read())

def show_help():
    print("How to use:\r\n")
    print("Dump Saturn memory to file:")
    print("{} d <filename> <address> <size>\r\n".format(sys.argv[0]))
    print("Jump to address:")
    print("{} j <address>\r\n".format(sys.argv[0]))
    print("Load file to address and execute:")
    print("{} r <filename> <address>\r\n".format(sys.argv[0]))
    print("Load file to address:")
    print("{} w <filename> <address>\r\n".format(sys.argv[0]))
    print("Examples:\r\n")
    print("{} d cart_rom_cs0.bin 0x02000000 0x40000 //dump 256kb cartridge rom".format(sys.argv[0]))
    print("{} d bkram.bin 0x00180000 0x10000 //dump Internal Battery backup RAM (saves)".format(sys.argv[0]))
    print("{} w bkram.bin 0x00180000 //restore Internal Battery backup RAM (saves) from bkram.bin".format(sys.argv[0]))
    print("{} r serial.bin 0x06004000 //upload and execute serial.bin from 0x06004000".format(sys.argv[0]))
    print("{} j 0x06004000 //jump to 0x06004000".format(sys.argv[0]))

if len(sys.argv) < 2:
    show_help()
    exit()
if sys.argv[1] == 'd':
    dump()
    exit()
elif sys.argv[1] == 'j':
    jump()
    exit()
elif sys.argv[1] == 'r' or sys.argv[1] =='w':
    run(sys.argv[1])
    exit()
else:
    show_help()
    exit()
